
#include "mocktcp.h"

#define TIMES 	500
#define SIZE 	10000
#define NUM 	7

main(int argc, char** argv)
{
	int	socks[NUM];
	int	port, res, i, count, sofar;
	char	*host, data[SIZE];

	if (argc != 3) {
		fprintf(stderr, "usage: client {host} {port}\n");
		exit(1);
	}

	host = argv[1];
	port  = atoi(argv[2]);

	fprintf(stderr, "sending to \"%s\" on port %d.\n", host, port);

	fprintf(stderr, "Opening new sockets...\n");
	for (i=0; i < NUM; i++) {
		socks[i] = mt_socket(); 
		if (socks[i] < 0) {
			perror("mt_socket");
			exit(1);
		}
	}

	fprintf(stderr, "Connecting...\n");
	for (i=0; i < NUM; i++) {
		res = mt_connect(socks[i], host, port);
		if (res < 0) {
			perror("mt_connect");
			exit(1);
		}
	}

	fprintf(stderr, "Ready.\n");
	for (count=0; ; count++) {
		if (count == TIMES) {
			fprintf(stderr, "Closing connection 4\n");
			res = mt_close(socks[3]);
			if (res < 0) {
				perror("mt_close");
				exit(1);
			}
			socks[3] = -1;
			fprintf(stderr, "done closing\n");
			sleep(1);
		}
		for (i=0; i < NUM; i++) {
			if (socks[i] == -1) continue;
			res = mt_write(socks[i], data, SIZE);
			if (res < 0) {
				perror("mt_write");
				exit(1);
			}
			sofar = 0;
			while (sofar < SIZE) {
				res = mt_read(socks[i], data, SIZE-sofar);
				if (res < 0) {
					perror("mt_read");
					exit(1);
				}
				sofar += res;
			}
		}
	}
}


