
#include "rmessage.h"

#define SIZE 4096
#define TIMES 10000

main(int argc, char** argv)
{
	int	s, port, res, i;
	char	*host, buf[SIZE];
	struct sockaddr_in to, from;

	if (argc != 3) {
		fprintf(stderr, "usage: client {host} {port}\n");
		exit(1);
	}

	host = argv[1];
	port  = atoi(argv[2]);

	fprintf(stderr, "sending to \"%s\" on port %d.\n", host, port);

	rm_init();
	s = rm_socket();
	if (s < 0) {
		perror("rm_socket");
		exit(1);
	}
	
	res = rm_fill_sockaddr(&to, host, port);
	if (s < 0) {
		perror("rm_fill_sockaddr");
		exit(1);
	}

	fprintf(stderr, "Sending...\n");
	/*
	res = rm_sendto(s, buf, SIZE, 0, &to);
	if (s < 0) {
		perror("rm_sendto");
		exit(1);
	}
	fprintf(stderr, "done.\n");
	sleep(1);
	exit(0);
	*/


	for (i=0; i < TIMES; i++) {
		if (i % 1000 == 0)
			fprintf(stderr, "\t%d\n", i);
		res = rm_sendto(s, buf, SIZE, 0, &to);
		if (s < 0) {
			perror("rm_sendto");
			exit(1);
		}
	}
	fprintf(stderr, "done.\n");

	sleep(1);
	exit(0);
	fprintf(stderr, "Receiving...\n");

	for (i=0; i < TIMES; i++) {
		if (i % 1000 == 0)
			fprintf(stderr, "\t%d\n", i);
		res = rm_recvfrom(s, buf, SIZE, 0, &from);
		if (s < 0) {
			perror("rm_recvfrom");
			exit(1);
		}
	}
	fprintf(stderr, "done.\n");

	sleep(1);

	rm_close(s);
}

