
#ifndef HASH_H
#define HASH_H

#include </n/rio/x/rio/dlowell/tcl_bsd/include/tcl.h>

typedef Tcl_HashTable hash_table;

#define HASH_STRING_KEYS TCL_STRING_KEYS
#define HASH_ONE_WORD_KEYS TCL_ONE_WORD_KEYS

#define hash_insert(h, k, v) hash_insert_f(h, ((char*)k), v)
#define hash_find(h, k) hash_find_f(h, ((char*)k))
#define hash_delete_entry(h, k) hash_delete_entry_f(h, ((char*)k))

extern void hash_init(hash_table *t, int type);
extern void hash_delete(hash_table *t);
extern void hash_insert_f(hash_table *t, char* key, void* val);
extern void* hash_find_f(hash_table *t, char* key);
extern void hash_delete_entry_f(hash_table *t, char* key);

#endif

